package org.iGEM.TU_Eindhoven;

import java.awt.GridLayout;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.apache.commons.math3.special.Erf;


public class Main {
	private static PrintWriter out;

	private static double r;
	private static int iteration;
	private static double deviationxy1;
	private static double deviationz1;
	private static double meanZ1;
	private static double deviationxy2;
	private static double deviationz2;
	private static double meanZ2;
	private static List<Double> distances = new ArrayList<Double>();
	private static Random rand = new Random();
	public static void main(String[] args)  throws IOException {	


		JPanel panel = new JPanel(new GridLayout(0, 1));
		JTextField field1 = new JTextField("");
		JTextField field2 = new JTextField("");
		JTextField field3 = new JTextField("");
		JTextField field4 = new JTextField("");
		JTextField field5 = new JTextField("");
		JTextField field6 = new JTextField("");
		JTextField field7 = new JTextField("");

		panel.add(new JLabel("Length of Linker (nm):"));
		panel.add(field1);
		panel.add(new JLabel("Persistence Length of Linker (nm)"));
		panel.add(field2);
		panel.add(new JLabel("Distance between Membrane Proteins (nm)"));
		panel.add(field3);
		panel.add(new JLabel("Radius of First Tethered Particle (nm)"));
		panel.add(field4);
		panel.add(new JLabel("Radius of Second Tethered Particle (nm)"));
		panel.add(field5);
		panel.add(new JLabel("Iterations:"));
		panel.add(field6);
		panel.add(new JLabel("Output File:"));
		panel.add(field7);


		int result = JOptionPane.showConfirmDialog(null, panel, "Please fill in the parameters",
				JOptionPane.OK_CANCEL_OPTION, JOptionPane.PLAIN_MESSAGE);
		if(result != 0){
			System.exit(0);
		}

		
		double L = Double.valueOf(field1.getText());
		double P = Double.valueOf(field2.getText());
		r = Double.valueOf(field3.getText());
		double Rp1 = Double.valueOf(field4.getText());
		double Rp2 = Double.valueOf(field5.getText());
		iteration = Integer.valueOf(field6.getText());
		out = new PrintWriter(field7.getText(),"UTF-8");


		double Nr = Rp1/Math.sqrt(P*L/3);		//calculate linker properties for both linkers, like mean values and deviation
		double erfNr = Erf.erf(Nr);
		deviationxy1 = Math.sqrt((P*L/3)*(2+((4*Nr)/(Math.sqrt(Math.PI) * erfNr))));
		deviationz1 = Math.sqrt((P*L/3)*(2+((4*Nr)/(Math.sqrt(Math.PI) * erfNr)) + Math.pow(Nr, 2)));
		meanZ1 = Math.sqrt(L*P/3)*(((2*(1- Math.pow(Math.E, -(Math.pow(Nr, 2)))))/(Math.sqrt(Math.PI)*erfNr)) + Nr * ((2-erfNr)/(erfNr)));

		Nr = Rp2/Math.sqrt(P*L/3);
		erfNr = Erf.erf(Nr);
		deviationxy2 = Math.sqrt((P*L/3)*(2+((4*Nr)/(Math.sqrt(Math.PI) * erfNr))));
		deviationz2 = Math.sqrt((P*L/3)*(2+((4*Nr)/(Math.sqrt(Math.PI) * erfNr)) + Math.pow(Nr, 2)));
		meanZ2 = Math.sqrt(L*P/3)*(((2*(1- Math.pow(Math.E, -(Math.pow(Nr, 2)))))/(Math.sqrt(Math.PI)*erfNr)) + Nr * ((2-erfNr)/(erfNr)));

		for(int i = 0; i < iteration ; i++){
			simulate();
		}

		for(Double A : distances){
			out.println(A);
		}
	}

	private static void simulate() {
		double angle = rand.nextDouble()*2*Math.PI;			//generate a random angle in radians

		double projectionRadius1 = rand.nextGaussian() * deviationxy1; 			// calculate the radius in the XY plane (lateral to the membrane)
		double projectionRadiusX1 = Math.sin(angle) * projectionRadius1;		//calculate the translation in the X-axis
		double projectionRadiusY1 = Math.cos(angle) * projectionRadius1; 		//same for the Y-axis
		double zRadius1 = (rand.nextGaussian() * deviationz1) + meanZ1;			//Calculate Z position (depth)

		angle = rand.nextDouble()*2*Math.PI;

		double projectionRadius2 = rand.nextGaussian() * deviationxy2;				//Do it again for the second membrane protein
		double projectionRadiusX2 = Math.sin(angle) * projectionRadius2 + Main.r; 	//Add the distance between the membrane proteins
		double projectionRadiusY2 = Math.cos(angle) * projectionRadius2;
		double zRadius2 = (rand.nextGaussian() * deviationz2) + meanZ2;

		//Calculate the distance between the two intracellular parts
		distances.add(Math.sqrt(Math.pow(projectionRadiusX1-projectionRadiusX2, 2) + Math.pow(projectionRadiusY1-projectionRadiusY2, 2) + Math.pow(zRadius1-zRadius2, 2)));
	}
}