package org.iGEM.TU_Eindhoven;


import java.util.Random;

public class Particle {
	private transient double x;
	private transient double y;
	transient double distance = 0;
	transient boolean BRET = false;
	transient Particle BRETPartner = null;
	private particleType type;

	public enum particleType {
		A, B;
	}

	Particle(particleType type){
		this.type = type;
		Random r = new Random();
		this.x = r.nextDouble() * Main.fieldSize;
		this.y = r.nextDouble() * Main.fieldSize;
		if(Main.particleList.isEmpty()){
			Main.particleList.add(this);
			return;
		}

		for(int i = 0 ; i < 1000000; i++){ //Try to place the particle. When a collision occurs try it again, up to a million times
			boolean error = false;
			this.x = r.nextDouble() * Main.fieldSize;
			this.y = r.nextDouble() * Main.fieldSize;
			for(Particle A : Main.particleList){
				if(Main.distance(x, A.getX(), y, A.getY()) < (Main.Rm * 2)){ //Check for a collision
					error = true;
					break;
				}
			}
			if(error == false){
				Main.particleList.add(this);
				return;
			}
		}
		System.out.println("Cannot place all molecules!");
		System.exit(1);
		//		this.renderList.add(this.x);
		//		this.renderList.add(this.y);

	}

	void setPosition(double x, double y){
		this.x = x;
		this.y = y;
	}
	double getX(){
		return x;
	}
	double getY(){
		return y;
	}

	particleType getType(){
		return type;
	}

}
